/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.gateway.common_gateway.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.gateway.common_gateway.entity.vo.AppBalanceBillsVO;
import org.springblade.ldt.bills.entity.BalanceBills;
import org.springblade.ldt.bills.vo.BalanceBillsVO;
import org.springblade.ldt.shop.entity.Shop;
import org.springblade.ldt.shop.service.IShopService;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-08-31
 */
public class AppBalanceBillsWrapper extends BaseEntityWrapper<BalanceBills, AppBalanceBillsVO>  {

	private IShopService shopService;

	public AppBalanceBillsWrapper(IShopService shopService) {
		this.shopService = shopService;
	}

	public static AppBalanceBillsWrapper build(IShopService shopService) {
		return new AppBalanceBillsWrapper(shopService);
 	}

	@Override
	public AppBalanceBillsVO entityVO(BalanceBills balanceBills) {
		AppBalanceBillsVO appBalanceBillsVO = Objects.requireNonNull(BeanUtil.copy(balanceBills, AppBalanceBillsVO.class));

		Long receiveId = appBalanceBillsVO.getReceiveId();
		Long payId = appBalanceBillsVO.getPayId();

		Shop shop = shopService.getById(receiveId);
		//赠送积分时shop为pay方
		Shop payShop = shopService.getById(payId);
		if (shop != null) {
			appBalanceBillsVO.setLogo(shop.getCover());
			appBalanceBillsVO.setName(shop.getName());
		}

		if (payShop != null) {
			appBalanceBillsVO.setLogo(payShop.getCover());
			appBalanceBillsVO.setName(payShop.getName());
		}

		return appBalanceBillsVO;
	}

}
